/* eslint-disable @next/next/no-img-element */
import {toast, ToastContainer} from "react-toastify";
import axios from "axios";
import {FormEvent, useEffect, useState} from "react";
import Head from "next/head";
import useUser from "@/hooks/useUser";
import {Divider} from "primereact/divider";
import Button from "@/components/Low/Button";
import {BsArrowRepeat} from "react-icons/bs";
import Link from "next/link";
import Input from "@/components/Low/Input";
import {useRouter} from "next/router";

export function getServerSideProps({
	query,
	res,
}: {
	query: {
		oobCode: string;
		mode: string;
		continueUrl?: string;
	};
	res: any;
}) {
	if (!query || !query.oobCode || !query.mode) {
		return {
			redirect: {
				destination: "/login",
				permanent: false,
			}
		};
	}

	return {
		props: {
			code: query.oobCode,
			mode: query.mode,
			...(query.continueUrl ? {continueUrl: query.continueUrl} : {}),
		},
	};
}

export default function Reset({code, mode, continueUrl}: {code: string; mode: string; continueUrl?: string}) {
	const [password, setPassword] = useState("");
	const [isLoading, setIsLoading] = useState(false);

	const router = useRouter();

	useUser({
		redirectTo: "/",
		redirectIfFound: true,
	});

	useEffect(() => {
		if (mode === "signIn") {
			axios
				.post<{ok: boolean}>("/api/reset/verify", {
					email: continueUrl?.replace("https://platform.encoach.com/", "").replace("https://staging.encoach.com/", ""),
				})
				.then((response) => {
					if (response.data.ok) {
						toast.success("Your account has been verified!", {
							toastId: "verify-successful",
						});
						setTimeout(() => {
							router.push("/");
						}, 1000);
						return;
					}

					toast.error("Something went wrong! Please make sure to click the link in your e-mail again and input the correct e-mail!", {
						toastId: "verify-error",
					});
				})
				.catch(() => {
					toast.error("Something went wrong! Please make sure to click the link in your e-mail again and input the correct e-mail!", {
						toastId: "verify-error",
					});
					setIsLoading(false);
				});
		}
	});

	const login = (e: FormEvent<HTMLFormElement>) => {
		e.preventDefault();

		setIsLoading(true);
		axios
			.post<{ok: boolean}>("/api/reset/confirm", {code, password})
			.then((response) => {
				if (response.data.ok) {
					toast.success("Your password has been reset!", {
						toastId: "reset-successful",
					});
					setTimeout(() => {
						router.push("/login");
					}, 1000);
					return;
				}

				toast.error("Something went wrong! Please make sure to click the link in your e-mail again!", {toastId: "reset-error"});
			})
			.catch(() => {
				toast.error("Something went wrong! Please make sure to click the link in your e-mail again!", {toastId: "reset-error"});
			})
			.finally(() => setIsLoading(false));
	};

	return (
		<>
			<Head>
				<title>Reset | EnCoach</title>
				<meta name="description" content="Generated by create next app" />
				<meta name="viewport" content="width=device-width, initial-scale=1" />
				<link rel="icon" href="/favicon.ico" />
			</Head>
			<main className="flex h-[100vh] w-full bg-white text-black">
				<ToastContainer />
				<section className="relative hidden h-full w-fit min-w-fit lg:flex">
					<div className="bg-mti-rose-light absolute z-10 h-full w-full bg-opacity-50" />
					<img src="/people-talking-tablet.png" alt="People smiling looking at a tablet" className="aspect-auto h-full" />
				</section>
				{mode === "resetPassword" && (
					<section className="flex h-full w-full flex-col items-center justify-center gap-2">
						<div className="relative flex flex-col items-center gap-2">
							<img src="/logo_title.png" alt="EnCoach's Logo" className="absolute -top-36 w-36 lg:-top-64 lg:w-64" />
							<h1 className="text-2xl font-bold lg:text-4xl">Reset your password</h1>
							<p className="text-mti-gray-cool self-start text-sm font-normal lg:text-base">to your registered Email Address</p>
						</div>
						<Divider className="max-w-xs lg:max-w-md" />
						<form className="-lg:px-8 flex w-full flex-col items-center gap-6 lg:w-1/2" onSubmit={login}>
							<Input type="password" name="password" onChange={(e) => setPassword(e)} placeholder="Password" />

							<Button className="mt-8 w-full" color="purple" disabled={isLoading}>
								{!isLoading && "Reset"}
								{isLoading && (
									<div className="flex items-center justify-center">
										<BsArrowRepeat className="animate-spin text-white" size={25} />
									</div>
								)}
							</Button>
						</form>
						<span className="text-mti-gray-cool mt-8 text-sm font-normal">
							Don&apos;t have an account?{" "}
							<Link className="text-mti-purple-light" href="/register">
								Sign up
							</Link>
						</span>
					</section>
				)}
				{mode === "signIn" && (
					<section className="flex h-full w-full flex-col items-center justify-center gap-2">
						<div className="relative flex flex-col items-center gap-2">
							<img src="/logo_title.png" alt="EnCoach's Logo" className="absolute -top-36 w-36 lg:-top-64 lg:w-64" />
							<h1 className="text-2xl font-bold lg:text-4xl">Confirm your account</h1>
							<p className="text-mti-gray-cool self-start text-sm font-normal lg:text-base">to your registered Email Address</p>
						</div>
						<Divider className="max-w-xs lg:max-w-md" />
						<div className="-lg:px-8 flex w-full flex-col items-center gap-6 lg:w-1/2">
							<span className="text-center">
								Your e-mail is currently being verified, please wait a second. <br /> <br />
								Once it has been verified, you will be redirected to the home page.
							</span>
						</div>
					</section>
				)}
			</main>
		</>
	);
}
